#! /bin/bash

#info
echo "information----------------------------------------------"
echo "---------------------------------------------------------"
echo "program for syncing windows vst synths"
echo "before installing windows dll vsts you need to have wine first"
echo "wine can be installed from the program manager in linux mint"
echo "Most of the vst2 will be located in folder"
echo "/home/$USER/.wine/drive_c/Program Files/Steinberg"
echo "if other maps are needed use the add path command "
echo "for removing obsolete vsts use the remove path command"
echo "for syncing new vsts after the folders are added use the sync command './yabridgectl sync'  "
echo "for checking the status use the './yabridgectl status'   command"
echo "if yabridge is not installed , you need to install it first as follows"
echo "download the tar file at location  https://github.com/robbert-vdh/yabridge/releases "
echo "unzip the file in location /home/$USER/.local/share/  first, to use yabridge"
echo "Your DAW (Ardour, lmms ect) needs to check follow  locations to implement the new vsts"
echo "/home/$USER/.VST"
echo "/home/$USER/.VST3"
echo "----------------------------------------------------------"
sleep 1
#vars
yalocation="/home/$USER/.local/share/"
yafolder="/home/$USER/.local/share/yabridge/"
vst2folder="/home/$USER/.vst/"
vst3folder="/home/$USER/.vst3/"
windowsfolder="/home/$USER/.wine/drive_c/Program Files"
#functions
check_install(){
if [ -d $yafolder ]; then
echo "--------------------------------------------------"
echo "yabridge is properly installed, now you can use it"
#xdg-open $yafolder
else
echo "-----------------------------------------------------"
echo "you need to install yabridge first to run this script"
echo "unzip the yabridge tarball in "$yalocation""
echo "and than run this script again"
xdg open $yalocation
sleep 5
program_exit
fi
}
program_exit(){
cd "/home/$USER"
echo "--------------------------"
echo "program will exit in 5 sec"
sleep 5
$SHELL
exit
}
selectfolder(){
foldername=$(zenity --file-selection --directory )
echo "you selected  "$foldername""
sleep 1
}
yabridgestatus(){
cd $yafolder
./yabridgectl status
}
yabridgeaddpath(){
cd $yafolder
./yabridgectl add "$foldername"
}
yabridgeremovepath(){
cd $yafolder
./yabridgectl rm "$foldername"
}
yabridgesync(){
cd $yafolder
./yabridgectl sync
}
yabridgelist(){
cd $yafolder
./yabridgectl list
}
yafolder(){
xdg-open $yafolder
xdg-open $vst2folder
xdg-open $vst3folder
xdg-open "$windowsfolder"
}
choisepattern(){
echo "-------------------------------------------"
echo " make your choise ?"
read -p "command a= add path  r= remove path s= sync windows vsts l= list vsts  o=open yabridgefolder e=exit " keuze
echo $keuze
case "$keuze" in
a)  echo "add new windows vst folderpath"
    selectfolder
    yabridgeaddpath
    echo "---------yabridge folders----------"
    yabridgelist
    ;;
r)  echo "remove windows vst folder path"
    selectfolder
    yabridgeremovepath
    echo "---------yabridge folders----------"
    yabridgelist
    ;;
s)  echo "sync windows vsts"
    yabridgesync
    yabridgestatus
    ;;
l) echo " list windows vst locations"
   yabridgelist
   ;;
o) echo " open yabridge folder and vst locations"
   yafolder
   ;;
esac
}
main(){
yabridgestatus
echo "------------------------------------------------"
echo " Check the above info to see if al your vsts are synced"
echo " and if all the path locations are ok"
echo " If not you can add or remove these search locations"
echo " If all locations are correct you can sync to add the new installed vsts in wine"
echo "
Commands yabridgectl:
  add        Add a plugin install location
  rm         Remove a plugin install location
  list       List the plugin install locations
  status     Show the installation status for all plugins
  sync       Set up or update yabridge for all plugins
"
choisepattern
vraagexit
}
vraagexit(){
read -p "do you wish to continue (y/n)  " keuze2
echo $keuze2
case "$keuze2" in
y)  choisepattern
    ;;
n)  program_exit
    ;;
esac
main
}
#program start from here
check_install
main
$SHELL
